// Browsing an array with TSBrowse

#define _VIDEO_CH
#define _DDE_CH

#include "Fivewin.ch"
#include "TSBrowse.ch"

#define CLR_PINK   nRGB( 255, 128, 128)
#define CLR_NBLUE  nRGB( 128, 128, 192)

//--------------------------------------------------------------------------//

Function Test()

   Local oDlg, oLbx, bData, bcolor, bAlign, bDelete, aBmp[ 2 ], Arr1, ;
         nTot2, nTot3, nGood, nBad, nPreVal, aColor[ 2 ], ;
         lNoBlink := .F.

   If ( aColor[ 1 ] := GetSysColor( COLOR_INACTIVECAPTION ) ) != ;
      GetSysColor( COLOR_ACTIVECAPTION )
      aColor[ 2 ] := GetSysColor( COLOR_INACTCAPTEXT ) 
      lNoBlink := .T.
      SBNoBlink()
   Endif

   Arr1 := {}
   AADD( Arr1, {"Ena         ", 100, 200} )
   AADD( Arr1, {"Dyo         ", 125, 200} )
   AADD( Arr1, {"Tria        ", 130, 200} )
   AADD( Arr1, {"Tessera     ", 135, 200} )
   AADD( Arr1, {"Pente       ", 140, 200} )
   AADD( Arr1, {"Exi         ", 145, 200} )
   AADD( Arr1, {"Epta        ", 150, 200} )
   AADD( Arr1, {"Okto        ", 100, 200} )
   AADD( Arr1, {"Ennea       ", 100, 200} )
   AADD( Arr1, {"Deka        ", 100, 200} )
   AADD( Arr1, {"Enteka      ", 100, 200} )
   AADD( Arr1, {"Dodeka      ", 100, 200} )
   AADD( Arr1, {"Dekatria    ", 100, 200} )
   AADD( Arr1, {"Dekatessera ", 100, 200} )
   AADD( Arr1, {"Dekapente   ", 100, 200} )
   AADD( Arr1, {"Dekaexi     ", 100, 200} )
   AADD( Arr1, {"Dekaepta    ", 100, 300} )
   AADD( Arr1, {"Dekaokto    ", 100, 200} )

    nTot2 := nTot3 := nGood := nBad := nPreVal := 0


   // footers values at start
   AEval( Arr1, { | e | nTot2 += e[ 2 ], nTot3 += e[ 3 ], ;
                        If( ( e[ 2 ] + e[ 3 ] ) < 325, ++nGood, ++nBad ) } )

   DEFINE BITMAP aBmp[ 1 ] FILE "..\bitmaps\Level1.Bmp"
   DEFINE BITMAP aBmp[ 2 ] FILE "..\bitmaps\Level2.Bmp"

   DEFINE DIALOG oDlg FROM 100,50 TO 400, 500 PIXEL Title ;
          "TSBrowse The Power of Columns ( Browsing an array )"

   @ 0,0 BROWSE oLbx  SIZE 225, 150 PIXEL OF oDlg CELLED; // CELLED is required
         COLORS CLR_BLACK, CLR_NBLUE                      // to edit cells

   oLbx:SetArray( Arr1 ) // this is necessary to work with arrays

   // let's define the block for background color
   bColor := { || If( oLbx:nAt % 2 == 0, CLR_PINK, CLR_NBLUE ) }

   ADD COLUMN TO BROWSE oLbx DATA ARRAY ELEMENT 1;
       TITLE "Col 1" ;
       SIZE 120 EDITABLE;          // this column is editable
       COLORS CLR_BLACK, bColor;   // background color from a Code Block
       3DLOOK TRUE, TRUE, TRUE;    // cells, titles, footers
       MOVE DT_MOVE_NEXT;          // cursor goes to next editable column
       VALID { | uVar | ! Empty( uVar ) }; // don't want empty rows
       ALIGN DT_LEFT, DT_CENTER, DT_RIGHT; // cells, title, footer
       FOOTER "Totals->"

   ADD COLUMN TO BROWSE oLbx DATA ARRAY ELEMENT 2;
       TITLE "Col 2"  ;
       ALIGN DT_RIGHT, DT_CENTER;  // let's align cells to right and center title
       SIZE 80 EDITABLE;           // this column is editable
       COLORS CLR_BLACK, bColor;   // background color from a Code Block
       3DLOOK TRUE, TRUE, TRUE;    // cells, titles, footers
       MOVE DT_MOVE_NEXT;          // cursor goes to next editable column
       FOOTER { || Transform( nTot2, "##,###" ) };  // must be a code block
       PREEDIT { | uVar | nPreVal := uVar }; // updating footer value
       POSTEDIT { | uVar | nTot2 += ( uVar - nPreval ), ;
                           If( Eval( oLbx:aColumns[ 4 ]:bData ) < 325, ;
                           If( oLbx:lChanged, ( ++nGood, --nBad ), Nil ), ;
                           If( oLbx:lChanged, ( ++nBad, --nGood ), Nil ) ), ;
                           oLbx:DrawFooters() }

   ADD COLUMN TO BROWSE oLbx DATA ARRAY ELEMENT 3;
       TITLE "Col 3"  ;
       ALIGN DT_RIGHT, DT_CENTER;  // let's align cells to right and center title
       SIZE 80  EDITABLE;          // this column is editable
       COLORS CLR_BLACK, bColor;   // background color from a Code Block
       3DLOOK TRUE, TRUE, TRUE;    // cells, titles, footers
       MOVE DT_MOVE_NEXT;          // cursor goes to next editable column
       FOOTER { || Transform( nTot3, "##,###" ) };  // must be a code block
       PREEDIT { | uVar | nPreVal := uVar }; // updating footer value
       POSTEDIT { | uVar | nTot3 += ( uVar - nPreval ), ;
                           If( Eval( oLbx:aColumns[ 4 ]:bData ) < 325, ;
                           If( oLbx:lChanged, ( ++nGood, --nBad ), Nil ), ;
                           If( oLbx:lChanged, ( ++nBad, --nGood ), Nil ) ), ;
                           oLbx:DrawFooters() }

   // next column is not part of the array, then bData must be defined apart
   bData := { || If( ! oLbx:lAppendMode, ;
                     oLbx:aArray[ oLbx:nAt, 2 ] + ;
                     oLbx:aArray[ oLbx:nAt, 3 ], 0 ) }

   // dynamic setting of background color for next column depending on cell's value
   bColor := { || If( Eval( oLbx:aColumns[ 4 ]:bData ) < 325, CLR_RED, CLR_CYAN ) }

   ADD COLUMN TO BROWSE oLbx DATA bData;
       TITLE "Col 4"  ;
       ALIGN DT_RIGHT, DT_CENTER;  // let's align cells to right and center title
       SIZE 80;                    // this column is NOT editable
       COLORS CLR_WHITE, bColor;   // background color from a Code Block
       3DLOOK TRUE, TRUE, TRUE;    // cells, titles, footers
       FOOTER { || Transform( nTot2 + nTot3, "##,###" ) }

   // with next column let's try BitMaps on cells with dynamic alignment
   bData := { || If( Eval( oLbx:aColumns[ 4 ]:bData ) < 325, ;
                     aBmp[ 1 ], aBmp[ 2 ] ) }

   bAlign := { || If( Eval( oLbx:aColumns[ 4 ]:bData ) < 325, ;
                      DT_LEFT, DT_RIGHT ) }

   ADD COLUMN TO BROWSE oLbx DATA bData ;
       BITMAP;                           // tells TSBrowse that data is a BitMap
       TITLE "Result" + CRLF + "Good      Bad"; // Multi-Line heading
       ALIGN bAlign, DT_CENTER, DT_CENTER; // cell, title, footer
       SIZE 71;                            // this column is NOT editable
       3DLOOK TRUE, TRUE, TRUE;            // cells, titles, footers
       FOOTER { || Str( nGood, 4 ) + " Good" + CRLF + ;
                Str( nBad, 4 ) + " Bad" }  // Multi-Line footer

   // activating Auto Append Mode
   oLbx:SetAppendMode( .T. )

   // activating Auto Delete Mode
   // I'll use bDelete code block to update footers
   bDelete := { | nAt, oBrw | nTot2 -= oBrw:aArray[ nAt, 2 ], ;
                              nTot3 -= oBrw:aArray[ nAt, 3 ], ;
                              If( ( oBrw:aArray[ nAt, 2 ] + ;
                                    oBrw:aArray[ nAt, 3 ] ) < 325, ;
                                    --nGood, --nBad ) }

   oLbx:SetDeleteMode( .T., .T., bDelete ) // ( lOnOff, lConfirm, bDelete )

   // Assigning default values to new elements created with Auto Append.
   // For last column (5), I'm using a code block to update footers without
   // assigning any value to that column, since code block returns Nil
   oLbx:aDefault := { Nil, 50, 50, Nil, ;
                      { || nTot2 += 50, nTot3 += 50, ++nGood, ;
                           oLbx:DrawFooters(), Nil } }

   // using Super Titles
   ADD SUPER HEADER TO oLbx FROM COLUMN 2 TO COLUMN 3 ;
       TITLE "Col2 and Col 3" 3DLOOK

   // increasing cell and super header height
   oLbx:nHeightCell += 2
   oLbx:nHeightSuper += 7

   Activate DIALOG oDlg ;
            VALID ( If( MsgYesNo("ok"), (aBmp[ 1 ]:End(), aBmp[ 2 ]:End(), ;
                    If( lNoBlink, SBNoBlink( aColor[ 1 ], aColor[ 2 ] ), ;
                        Nil ), .T.), ( oDlg:Refresh(), .F. ) ) )

Return Nil

