*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Creating Browse From resources
*=============================================================================

#xcommand REDEFINE [ COLUMN ] BROWSE  <oBrw>  ;
             [ FIELDS  ] [ <Flds,...> ];
             [ ALIAS <cAlias> ] ;
             [ ID <nId> ] ;
             [ <dlg:OF,DIALOG> <oDlg> ] ;
             [ <sizes:FIELDSIZES, SIZES, COLSIZES> <aColSizes,...> ] ;
             [ <head:HEAD,HEADER,HEADERS> <aHeaders,...> ] ;
             [ SELECT <cField> FOR <uValue1> [ TO <uValue2> ] ] ;
             [ ON CHANGE <uChange> ] ;
             [ ON [ LEFT ] CLICK <uLClick> ] ;
             [ ON [ LEFT ] DBLCLICK <uLDblClick> ] ;
             [ ON RIGHT CLICK <uRClick> ] ;
             [ FONT <oFont> ] ;
             [ CURSOR <oCursor> ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ MESSAGE <cMsg> ] ;
             [ <update: UPDATE> ] ;
             [ WHEN <uWhen> ] ;
             [ VALID <uValid> ] ;
             [ <cell: CELL, CELLED, GRID> ] ;
       => ;
   <oBrw> := TSBrowse():ReDefine( <nId>, ;
             [ \{|| \{ <Flds> \} \} ], [ <oDlg> ], ;
             [ \{<aHeaders>\} ], [ \{<aColSizes>\} ],;
               <(cField)>, <uValue1>, <uValue2>, ;
             [ <{uChange}> ],;
             [ \{|nRow,nCol,nFlags|<uLDblClick>\} ], ;
             [ \{|nRow,nCol,nFlags|<uRClick>\} ], ;
             [ <oFont> ], [ <oCursor> ], [ \{<aColors>\} ], ;
             [ <cMsg> ], [ <.update.> ], [ <(cAlias)> ], ;
             [ <{uWhen}> ], [ <{uValid}> ], [ <.cell.> ], ;
             [ \{|nRow,nCol,nFlags|<uLClick>\} ] )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Creating Browse From Code
*=============================================================================

#xcommand @ <nRow>, <nCol> BROWSE  <oBrw>  ;
             [ FIELDS <Flds,...> ] ;
             [ ALIAS <cAlias> ] ;
             [ <sizes:FIELDSIZES, SIZES, COLSIZES> <aColSizes,...> ] ;
             [ <head:HEAD,HEADER,HEADERS> <aHeaders,...> ] ;
             [ SIZE <nWidth>, <nHeigth> ] ;
             [ <dlg:OF,DIALOG> <oDlg> ] ;
             [ SELECT <cField> FOR <uValue1> [ TO <uValue2> ] ] ;
             [ ON CHANGE <uChange> ] ;
             [ ON [ LEFT ] CLICK <uLClick> ] ;
             [ ON [ LEFT ] DBLCLICK <uLDblClick> ] ;
             [ ON RIGHT CLICK <uRClick> ] ;
             [ FONT <oFont> ] ;
             [ CURSOR <oCursor> ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ MESSAGE <cMsg> ] ;
             [ <update: UPDATE> ] ;
             [ <pixel: PIXEL, PIXELS> ] ;
             [ WHEN <uWhen> ] ;
             [ <design: DESIGN> ] ;
             [ VALID <uValid> ] ;
             [ <cell: CELL, CELLED, GRID> ] ;
             [ STYLE <nStyle> ] ;
       => ;
   <oBrw> := TSBrowse():New( <nRow>, <nCol>, [ <nWidth> ], [ <nHeigth> ], ;
             [  \{|| \{ <Flds> \} \} ], ;
             [ \{<aHeaders>\} ], [ \{<aColSizes>\} ], ;
             [ <oDlg> ], <(cField)>, <uValue1>, <uValue2>, ;
             [ <{uChange}> ], ;
             [ \{|nRow,nCol,nFlags|<uLDblClick>\} ], ;
             [ \{|nRow,nCol,nFlags|<uRClick>\} ], ;
             [ <oFont> ], [ <oCursor> ], [ \{<aColors>\} ], ;
             [ <cMsg> ], [ <.update.> ], [ <(cAlias)> ], [ <.pixel.> ], ;
             [ <{uWhen}> ], [ <.design.> ], [ <{uValid}> ], [ <.cell.> ], ;
             [ <nStyle> ], [ \{|nRow,nCol,nFlags|<uLClick>\} ] )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Defining Column Objects ( General Data )
*=============================================================================

#command DEFINE COLUMN <oCol> ;
             [ <dat: DATA, SHOWBLOCK> <uData> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ];
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIN> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECKBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <idx: ORDER, INDEX, TAG> <cOrder> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <l3D: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
   <oCol> := TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
             [ If( ValType(<uData>)=="B", <uData>, <{uData}> ) ], ;
             [ <cPicture> ], [ \{<aColors>\} ], [ \{<aAlign>\} ], ;
             [ <nWidth> ], [ <.bit.> ], [ <.edit.> ], ;
             [ <{uValid}> ], [ <.lite.> ], [ <(cOrder)> ], ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ], ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ], [ <{uWhen}> ] )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Column to Browse( General Data )
*=============================================================================

#command ADD [ COLUMN ] TO [ BROWSE ] <oBrw> ;
             [ <dat: DATA, SHOWBLOCK> <uData> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ] ;
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIGNS> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECKBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <idx: ORDER, INDEX, TAG> <cOrder> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <look3d: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
    <oBrw>:AddColumn( TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
             [ If( ValType(<uData>)=="B", <uData>, <{uData}> ) ], ;
             [ <cPicture> ], [ \{<aColors>\} ], ;
             [ \{<aAlign>\} ], [ <nWidth> ], ;
             [ <.bit.> ], [ <.edit.> ], [ <{uValid}> ], ;
             [ <.lite.> ], [ <(cOrder)> ], ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ], ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ], [ <{uWhen}> ], <oBrw> ) )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Column to Browse ( Array Data )
*=============================================================================

#command ADD [ COLUMN ] TO [ BROWSE ] <oBrw> [ DATA ] ARRAY ;
             [ <el: ELM, ELEMENT> <elm> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ];
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;  // <new193>  added by LKM 28/Mar/97
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIGNS> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECKBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <l3D: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
             [ WHEN <uWhen> ] ;
       => ;
    <oBrw>:AddColumn( TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
               \{|x| If(PCount() > 0, <oBrw>:aArray\[<oBrw>:nAt, <elm>\] := x, ;
                     <oBrw>:aArray\[<oBrw>:nAt, <elm>\])\}, [ <cPicture> ], ;
             [ \{<aColors>\} ], [ \{<aAlign>\} ], [ <nWidth> ], ;
             [ <.bit.> ], [ <.edit.> ], [ <{uValid}> ], ;
             [ <.lite.> ], Nil, ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ], ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ], [ <{uWhen}> ], <oBrw> ) )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Column to Browse ( TDataBase .and. TMultiDBF Classes Data )
*=============================================================================

#command ADD [ COLUMN ] TO [ BROWSE ] <oBrw> [ DATA ] ;
               <fi: oDBF, FIELD> [FIELD] <field> ;
             [ ALIAS <cAlias> ] ;
             [ <tit: TITLE, HEADER> <cHead> [ <oem: OEM, ANSI, CONVERT>] ] ;
             [ <foot: FOOT,FOOTER,FOOTERS> <cFoot> [ <oem2: OEM, ANSI, CONVERT>] ] ;  // <new193>  added by LKM 28/Mar/97
             [ <color: COLOR, COLORS> <aColors,...> ] ;
             [ <align: ALIGN, ALIGNS> <aAlign,...> ] ;
             [ <wid: WIDTH, SIZE> <nWidth> [ PIXELS ] ] ;
             [ PICTURE <cPicture> ] ;
             [ <bit: BITMAP, CHECKBOX> ] ;
             [ <edit: EDITABLE> ] ;
             [ VALID <uValid> ] ;
             [ <lite: NOBAR, NOHILITE> ] ;
             [ <idx: ORDER, INDEX, TAG> <cOrder> ] ;
             [ <pre: PRE EDIT, PREEDIT> <bPrevBlock> ] ;
             [ <pst: POST EDIT,POSTEDIT> <bPostBlock> ] ;
             [ <mov: MOVE, SHIFT> <nMoveDir> ] ;
             [ <cur: DBLCURSOR, DOUBLE CURSOR, FIXED> ] ;
             [ <l3D: LOOK3D, 3DLOOK> <a3DLook,...> ] ;
       => ;
    <oBrw>:AddColumn( TSColumn():New( ;
             [ If(<.oem.>, OemToAnsi(<cHead>), <cHead>) ], ;
               \{|x| If(PCount() > 0, <oBrw>:oDbf:[<cAlias>:]<field> := x, ;
                       <oBrw>:oDbf:[<cAlias>:]<field>) \}, [ <cPicture> ], ;
             [ \{<aColors>\} ], [ \{<aAlign>\} ], [ <nWidth> ], ;
             [ <.bit.> ], [ <.edit.> ], [ <{uValid}> ], [ <.lite.> ], ;
             [ <(cOrder)> ], ;
             [ If(<.oem2.>, OemToAnsi(<cFoot>), <cFoot>) ] , ;
             [ <{bPrevBlock}> ], [ <{bPostBlock}> ], [ <nMoveDir> ], ;
             [ <.cur.> ], [ \{<a3DLook>\} ],, <oBrw> ) )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Adding Super Headings to Browse
*=============================================================================

#command ADD [ SUPER ] HEADER TO <oBrw> ;
             FROM [ COLUMN ] <nFrom> ;
             TO [ COLUMN ] <nTo> ;
             [ <head:TITLE, HEADER> <cHead> ] ;
             [ HEIGHT <nHeight> ] ;
             [ <color:COLOR, COLORS> <aColors,...> ] ;
             [ <l3dLook: 3DLOOK, LOOK3D> ] ;
             [ FONT <uFont> ] ;
             [ <lGrid:NOGRID, NOLINES> ] ;
             [ <lBit:BITMAP> ] ;
             [ <lAdj:ADJUST> ] ;
             [ <lTra:TRANSPARENT> ] ;
             [ <horz:HORZ, HORZ ALIGN> <nHAlign> ] ;
             [ <vert:VERT, VERT ALIGN> <nVAlign> ] ;
       => ;
       <oBrw>:AddSuperHead( <nFrom>, <nTo>, <cHead>, [ <nHeight> ], ;
                            [ \{<aColors>\} ], <.l3dLook.>, <uFont>, ;
                            <.lBit.>, <.lAdj.>, <.lTra.>, <.lGrid.>, ;
                            <nHAlign>, <nVAlign> )

*=============================================================================
* TSBrowse.ch  Version 4.0 1/Jan/2002
* Predefined Constants
*=============================================================================

// Horizontal alignment
#define DT_LEFT              0
#define DT_CENTER            1
#define DT_RIGHT             2
#define DT_VERT              3  // vertical text (only for headers)
#define DT_CENTERED          DT_CENTER

// Vertical alignment
#define DT_TOP               0
#define DT_BOTTOM            2

// Cursor movement after editing
#define DT_DONT_MOVE         0
#define DT_MOVE_RIGHT        1
#define DT_MOVE_DOWN         2
#define DT_MOVE_LEFT         3
#define DT_MOVE_UP           4
#define DT_MOVE_NEXT         5

// Report method() language text selection
#define DT_DATE              1
#define DT_PAGE              2
#define DT_TIME              3
#define DT_PREVIEW           4

#define DT_SPANISH           1
#define DT_ENGLISH           2

#define __FLAT__

// Flags for phantom column: with or without a grid
#define PHCOL_GRID          -1
#define PHCOL_NOGRID        -2

// Default text sizes
#define BRSE_CHARPIX_H      14
#define BRSE_CHARPIX_W       8

// Line Styles
#define LINES_NONE           0
#define LINES_ALL            1
#define LINES_VERT           2
#define LINES_HORZ           3
#define LINES_3D             4
#define LINES_DOTTED         5

// aColors items number
#define CLR_TEXT             1   // text
#define CLR_PANE             2   // back
#define CLR_HEADF            3   // header text
#define CLR_HEADB            4   // header back
#define CLR_FOCUSF           5   // focused text
#define CLR_FOCUSB           6   // focused back
#define CLR_EDITF            7   // editing text
#define CLR_EDITB            8   // editing back
#define CLR_FOOTF            9   // footer text
#define CLR_FOOTB           10   // footer back
#define CLR_SELEF           11   // focused inactive text
#define CLR_SELEB           12   // focused inactive back
#define CLR_ORDF            13   // order column text
#define CLR_ORDB            14   // order column back
#define CLR_LINE            15   // grid lines

// System Colors
#define COLOR_ACTIVECAPTION          2
#define COLOR_INACTIVECAPTION        3
#define COLOR_WINDOW                 5
#define COLOR_WINDOWTEXT             8
#define COLOR_CAPTIONTEXT            9
#define COLOR_HIGHLIGHT             13
#define COLOR_HIGHLIGHTTEXT         14
#define COLOR_BTNFACE               15
#define COLOR_BTNSHADOW             16
#define COLOR_BTNTEXT               18
#define COLOR_INACTCAPTEXT          19
#define COLOR_BTNHIGHLIGHT          20

// Styles
#define DS_3DLOOK                    4
#define GWL_STYLE                  -16

#define CS_DBLCLKS                   8
#define TRUE                        .T.
#define FALSE                       .F.

// General TSBrowse Language
//#define _SPANISH_       // comment this line if want english messages

//------------------------------------------------------------------------//

#translate VALID <if: IF, CONDITION> <cond> => ;
                   VALID \{|o, x| x := o:varGet(), <cond> \}

//-------------------------------------------------------------------------//
